import axios from "axios"
//import store from '@/store';

// export const RESET = 'RESET';


/* const initialState = () => ({ // ? closure ?
  form: null,
  colorsStyleList: [],
  customForms: [],
  current_feature_type_slug: null,
  feature_types: [],
}); */

const feature_type = {
  namespaced: true,
  //state: initialState(),
  state: {
    form: null,
    colorsStyleList: [],
    customForms: [],
    current_feature_type_slug: null,
    feature_types: [],
    importFeatureTypeData: [],
  },

  mutations: {
    /* [RESET]: (state) => {
      const newState = initialState();
      Object.keys(newState).forEach((key) => {
        state[key] = newState[key];
      });
    }, */
    SET_FEATURE_TYPES(state, feature_types) {
      state.feature_types = feature_types;
    },
    SET_CURRENT_FEATURE_TYPE_SLUG(state, payload) {
      state.current_feature_type_slug = payload;
    },
    UPDATE_FORM(state, payload) {
      state.form = payload;
    },
    ADD_CUSTOM_FORM(state, customForm) {
      state.customForms = [...state.customForms, customForm];
    },
    UPDATE_CUSTOM_FORM(state, payload) {
      const index = state.customForms.findIndex((el) => el.dataKey === payload.dataKey);
      if (index !== -1) state.customForms[index] = payload
    },
    REMOVE_CUSTOM_FORM(state, payload) {
      state.customForms = state.customForms.filter(form => form.dataKey !== payload);
    },
    UPDATE_COLOR_STYLE(state) { // * un peu dirty (mais pas quick) car getter pas réactif avec nested et compliqué de faire dans composants enfants multiples
      let res = [];
      for (let form of state.customForms) {
        if (form.label) res.push(form);
      }
      state.colorsStyleList = res;
    },
    SET_IMPORT_FEATURE_TYPES_DATA(state, payload) {
      state.importFeatureTypeData = payload;
    },
    EMPTY_CUSTOM_FORMS(state) {
      state.customForms = [];
    }
  },
  getters: {
    feature_type: state => state.feature_types.find(
      (el) => el.slug === state.current_feature_type_slug
    )
  },
  actions: {
    /*  [RESET]: ({ commit }) => {
       commit("RESET_STATE");
     }, */
    POST_FEATURE_TYPE({ state, rootGetters }) {
      const data = {
        'title': state.form.title.value,
        'slug': rootGetters.project.slug,
        'geom_type': state.form.geom_type.value,
        'color': state.form.color.value,
        'colors_style': state.form.colors_style.value,
        'project': rootGetters.project.slug,
        //'project': state.form.project.value,
        'customfield_set': state.customForms.map(el => {
          return {
            'position': el.position,
            'label': el.label,
            'name': el.name,
            'field_type': el.field_type,
            'options': el.options,
          }
        }),
        //'is_editable': true,
      }
      console.log("data", data)

      axios
        .post(`${process.env.VUE_APP_DJANGO_API_BASE}feature-types/`, data)
        .then((response) => {
          console.log(response)
        })
        .catch((error) => {
          console.error(error);
        });
    },

    POST_FEATURES_FROM_GEOJSON({ dispatch }, payload) {
      const { slug, feature_type_slug, filenameToImport } = payload

      if (filenameToImport.size > 0) {
        var formData = new FormData();
        formData.append("json_file", filenameToImport);
        let url =
          process.env.VUE_APP_URL_BASE +
          "projet/" + slug +
          "/type-signalement/" + feature_type_slug +
          "/importer-geojson/";
        axios
          .post(url, formData, {
            headers: {
              "Content-Type": "multipart/form-data",
            },
          })
          .then((response) => {
            if (response.status == 200) {
              dispatch("GET_IMPORTS", feature_type_slug);
              // TODO : RELOAD DERNIER SIGNALEMENTS
            }
          })
          .catch((err) => {
            // TODO : HANDLER ERROR
            console.log(err);
          });
      }
    },

    GET_IMPORTS({ commit }, feature_type) {
      let url =
        process.env.VUE_APP_DJANGO_API_BASE +
        "import-tasks?feature_type_id=" +
        feature_type;
      axios
        .get(url)
        .then((response) => {
          commit("SET_IMPORT_FEATURE_TYPES_DATA", response.data);
        })
        .catch((err) => {
          console.log(err);
        });
    }
  }
}

export default feature_type